%{!?scl:%global pkg_name %{name}}

%global pa_version 0.11.7

Name:           preupgrade-assistant
Version:        0.11.7
Release:        1%{?dist}
Summary:        Preupgrade assistant performs assessment of the system
License:        GPLv3+
URL:            https://github.com/phracek/preupgrade-assistant
Source0:        https://github.com/phracek/%{name}/archive/%{pa_version}.tar.gz
Source1:        macros.preupgrade-assistant
Patch0:         preupgrade-assistant-do-not-ship-ui.patch
BuildArch:      noarch

BuildRequires:  rpm-devel
%if %{?_with_check:1}%{!?_with_check:0}
BuildRequires:  perl-XML-XPath
%endif
BuildRequires:  openscap-engine-sce >= 0:1.0.8-1
BuildRequires:  openscap-utils >= 0:1.0.8-1
BuildRequires:  openscap >= 0:1.0.8-1
Requires:       openscap >= 0:1.0.8-1
Requires:       openscap-engine-sce >= 0:1.0.8-1
Requires:       openscap-utils >= 0:1.0.8-1
Requires:       coreutils grep gawk
Requires:       sed findutils bash
%if 0%{?fedora} == 22
BuildRequires:  pykickstart
BuildRequires:  python2-devel
BuildRequires:  python-setuptools
BuildRequires:  python-six
BuildRequires:  python-requests
BuildRequires:  rpm-python
Requires:       python-setuptools
Requires:       python-six
Requires:       python-requests
Requires:       rpm-python
Requires:       pykickstart
%else
BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
BuildRequires:  python3-six
BuildRequires:  python3-requests
BuildRequires:  rpm-python3
BuildRequires:  python3-kickstart
Requires:       python3-kickstart
Requires:       python3-setuptools
Requires:       python3-six
Requires:       python3-requests
Requires:       rpm-python3
%endif

%description
Preupgrade assistant performs assessment of the system from
the "upgradeability" point of view. Such analysis includes check for removed
packages, packages replaced by partially incompatible packages, changes in
libraries, users and groups and various services. Report of this analysis
can help the admin with the inplace upgrade - by identification of potential
troubles and by mitigating some of the incompatibilities. Data gathered
by preupgrade assistant can be used for the "cloning" of the system - new,
clean installation of the system, as close as possible to the old Fedora setup.
In addition, it provides some postupgrade scripts which are supposed to finish
migration after the installation of Fedora system.


%prep
%setup -q -n %{name}-%{version}
%patch0 -p1 -b .not-ui

rm -rf preup_ui
rm -rf ui-conf

%build
%if 0%{?fedora} == 22
%{__python2} setup.py build
%else
%{__python3} setup.py build
%endif

%check
%if 0%{?fedora} == 22
%{__python2} setup.py test
%else
%{__python3} setup.py test
%endif

%install

#Preupgrade snd Premigrate tuff
mkdir -p -m 755 $RPM_BUILD_ROOT%{_datadir}/preupgrade/{xsl,common,postupgrade.d,kickstart}

mkdir -p -m 755 $RPM_BUILD_ROOT%{_datadir}/sectool-sce/
mkdir -p -m 755 $RPM_BUILD_ROOT%{_docdir}/preupgrade

install -d -m 755 $RPM_BUILD_ROOT%{_libdir}/preupgrade
install -d -m 755 $RPM_BUILD_ROOT%{_localstatedir}/log/preupgrade
%{__install} -p -m 644 -D %SOURCE1 $RPM_BUILD_ROOT%{_rpmconfigdir}/macros.d/macros.preupgrade-assistant

%if 0%{?fedora} == 22
%{__python2} setup.py install --skip-build --root=$RPM_BUILD_ROOT
%else
%{__python3} setup.py install --skip-build --root=$RPM_BUILD_ROOT
%endif

%global egg_name %(echo %{name} | sed s/-/_/)

%{__install} -p -m 644 -D man/preupg.1 $RPM_BUILD_ROOT%{_mandir}/man1/preupg.1


%if 0%{?fedora} == 22
rm -rf  ${RPM_BUILD_ROOT}%{python2_sitelib}/preup_ui/
%else
rm -rf  ${RPM_BUILD_ROOT}%{python3_sitelib}/preup_ui/
%endif
rm -f   ${RPM_BUILD_ROOT}%{_bindir}/preup_ui_manage
rm -rf  ${RPM_BUILD_ROOT}%{_datadir}/preupgrade/kickstart
rm -rf  ${RPM_BUILD_ROOT}%{_datadir}/premigrate
rm -rf  ${RPM_BUILD_ROOT}%{_datadir}/preupgrade/xsl
rm -f ${RPM_BUILD_ROOT}%{_bindir}/premigrate

%files
%license LICENSE
%{_bindir}/preupg
%if 0%{?fedora} == 22
%dir %{python2_sitelib}/preup
%{python2_sitelib}/preup/*
%{python2_sitelib}/%{egg_name}*.egg-info
%else
%dir %{python3_sitelib}/preup
%{python3_sitelib}/preup/*
%{python3_sitelib}/%{egg_name}*.egg-info
%endif
# Preupgrade stuff
%dir %{_datadir}/preupgrade
%{_datadir}/preupgrade/common
%{_datadir}/preupgrade/common.sh
%{_datadir}/preupgrade/postupgrade.d
%{_datadir}/preupgrade/README.kickstart
%{_datadir}/preupgrade/README
%doc README
%{_localstatedir}/log/preupgrade
%{_mandir}/man1/*
%{_bindir}/preupg-create-group-xml
%{_bindir}/preupg-xccdf-compose
%if 0%{?fedora} == 22
%dir %{python2_sitelib}/preuputils
%{python2_sitelib}/preuputils/*
%else
%dir %{python3_sitelib}/preuputils
%{python3_sitelib}/preuputils/*
%endif
%{_rpmconfigdir}/macros.d/macros.preupgrade-assistant

%changelog
* Mon Mar 09 2015 Petr Hracek <phracek@redhat.com> 0.11.7-1
- Initial rpm
